﻿
using eRechnung;
using Microsoft.VisualStudio.TestTools.UnitTesting;
using System;
using eRechnung.ExtensionMethods;

namespace ebGLN_Checker.GLN_ErrorCodeerface.Test
{

    /// <summary>
    ///Dies ist eine Testklasse für "GLN_CheckerTest" und soll
    ///alle GLN_CheckerTest Komponententests enthalten.
    ///</summary>
    [TestClass()]
    public class GLN_CheckerTest
    {


        private TestContext testContextInstance;

        /// <summary>
        ///Ruft den Testkontext auf, der Informationen
        ///über und Funktionalität für den aktuellen Testlauf bietet, oder legt diesen fest.
        ///</summary>
        public TestContext TestContext
        {
            get
            {
                return testContextInstance;
            }
            set
            {
                testContextInstance = value;
            }
        }

        #region Zusätzliche Testattribute
        // 
        //Sie können beim Verfassen Ihrer Tests die folgenden zusätzlichen Attribute verwenden:
        //
        //Mit ClassInitialize führen Sie Code aus, bevor Sie den ersten Test in der Klasse ausführen.
        //[ClassInitialize()]
        //public static void MyClassInitialize(TestContext testContext)
        //{
        //}
        //
        //Mit ClassCleanup führen Sie Code aus, nachdem alle Tests in einer Klasse ausgeführt wurden.
        //[ClassCleanup()]
        //public static void MyClassCleanup()
        //{
        //}
        //
        //Mit TestInitialize können Sie vor jedem einzelnen Test Code ausführen.
        //[TestInitialize()]
        //public void MyTestInitialize()
        //{
        //}
        //
        //Mit TestCleanup können Sie nach jedem einzelnen Test Code ausführen.
        //[TestCleanup()]
        //public void MyTestCleanup()
        //{
        //}
        //
        #endregion


        /// <summary>
        ///Ein Test für "IsValidGLN" Empty
        ///</summary>
        [TestMethod()]
        public void IsValidGLN_EmptyTest()
        {
            string gln = string.Empty; 
            GLN_Checker.GLN_ErrorCode expected = GLN_Checker.GLN_ErrorCode.NichtNumerisch; 
            GLN_Checker.GLN_ErrorCode actual;
            actual = GLN_Checker.IsValidGLN(gln);
            Assert.AreEqual(expected, actual);
            // Assert.Inconclusive("Überprüfen Sie die Richtigkeit dieser Testmethode.");
        }

        /// <summary>
        /// Ein Test für "IsValidGLN" 
        /// Not Numeric
        ///</summary>
        [TestMethod()]
        public void IsValidGLN_NotNumericTest()
        {
            string gln = "01234567891a23"; 
            GLN_Checker.GLN_ErrorCode expected = GLN_Checker.GLN_ErrorCode.NichtNumerisch; 
            GLN_Checker.GLN_ErrorCode actual;
            actual = GLN_Checker.IsValidGLN(gln);
            Assert.AreEqual(expected, actual);
            // Assert.Inconclusive("Überprüfen Sie die Richtigkeit dieser Testmethode.");
        }

        /// <summary>
        ///Ein Test für "IsValidGLN" 
        /// Invalid Length
        ///</summary>
        [TestMethod()]
        public void IsValidGLN_InvalidLengthTest()
        {
            string gln = "123456789";
            GLN_Checker.GLN_ErrorCode expected = GLN_Checker.GLN_ErrorCode.Längefalsch;
            GLN_Checker.GLN_ErrorCode actual;
            actual = GLN_Checker.IsValidGLN(gln);
            Assert.AreEqual(expected, actual);
            // Assert.Inconclusive("Überprüfen Sie die Richtigkeit dieser Testmethode.");
        }

        //
        /// <summary>
        ///Ein Test für "IsValidGLN" 
        /// Invalid Length  
        ///</summary>
        [TestMethod()]
        public void IsValidGLN_ValidGLNTest()
        {
            string gln = "9120004220004";
            GLN_Checker.GLN_ErrorCode expected = GLN_Checker.GLN_ErrorCode.OK;
            GLN_Checker.GLN_ErrorCode actual;
            actual = GLN_Checker.IsValidGLN(gln);
            Assert.AreEqual(expected, actual);
            // Assert.Inconclusive("Überprüfen Sie die Richtigkeit dieser Testmethode.");
        }

        [TestMethod()]
        public void IsValidGLN_ValidGLNTestWithZeroEnding()
        {
            string gln = "9120013480000";
            GLN_Checker.GLN_ErrorCode expected = GLN_Checker.GLN_ErrorCode.OK;
            GLN_Checker.GLN_ErrorCode actual;
            actual = GLN_Checker.IsValidGLN(gln);
            Assert.AreEqual(expected, actual);
            // Assert.Inconclusive("Überprüfen Sie die Richtigkeit dieser Testmethode.");
        }

    }

}
